package io.fabric8.kubernetes.api.model.apps;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class DaemonSetConditionBuilder extends io.fabric8.kubernetes.api.model.apps.DaemonSetConditionFluentImpl<io.fabric8.kubernetes.api.model.apps.DaemonSetConditionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.apps.DaemonSetCondition,io.fabric8.kubernetes.api.model.apps.DaemonSetConditionBuilder>{
  public DaemonSetConditionBuilder() {
    this(false);
  }
  public DaemonSetConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new DaemonSetCondition(), validationEnabled);
  }
  public DaemonSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.DaemonSetConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public DaemonSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.DaemonSetConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new DaemonSetCondition(), validationEnabled);
  }
  public DaemonSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.DaemonSetConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.apps.DaemonSetCondition instance) {
    this(fluent, instance, false);
  }
  public DaemonSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.DaemonSetConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.apps.DaemonSetCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLastTransitionTime(instance.getLastTransitionTime()); 
    fluent.withMessage(instance.getMessage()); 
    fluent.withReason(instance.getReason()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public DaemonSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.DaemonSetCondition instance) {
    this(instance,false);
  }
  public DaemonSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.DaemonSetCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLastTransitionTime(instance.getLastTransitionTime()); 
    this.withMessage(instance.getMessage()); 
    this.withReason(instance.getReason()); 
    this.withStatus(instance.getStatus()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.apps.DaemonSetConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.apps.DaemonSetCondition build() {
    DaemonSetCondition buildable = new DaemonSetCondition(fluent.getLastTransitionTime(),fluent.getMessage(),fluent.getReason(),fluent.getStatus(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    DaemonSetConditionBuilder that = (DaemonSetConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}