package io.fabric8.kubernetes.api.model.apps;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Nested;
import java.lang.String;
import io.fabric8.kubernetes.api.model.PodTemplateSpec;
import java.lang.Deprecated;
import java.lang.Boolean;
import io.fabric8.kubernetes.api.model.LabelSelectorBuilder;
import io.fabric8.kubernetes.api.builder.Fluent;
import io.fabric8.kubernetes.api.model.LabelSelector;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.PodTemplateSpecBuilder;
import io.fabric8.kubernetes.api.model.PodTemplateSpecFluent;
import java.lang.Object;
import io.fabric8.kubernetes.api.model.LabelSelectorFluent;
import java.util.Map;

 /**
  * Generated
  */
public interface DeploymentSpecFluent<A extends io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public java.lang.Integer getMinReadySeconds();
  public A withMinReadySeconds(java.lang.Integer minReadySeconds);
  public java.lang.Boolean hasMinReadySeconds();
  public java.lang.Boolean getPaused();
  public A withPaused(java.lang.Boolean paused);
  public java.lang.Boolean hasPaused();
  public java.lang.Integer getProgressDeadlineSeconds();
  public A withProgressDeadlineSeconds(java.lang.Integer progressDeadlineSeconds);
  public java.lang.Boolean hasProgressDeadlineSeconds();
  public java.lang.Integer getReplicas();
  public A withReplicas(java.lang.Integer replicas);
  public java.lang.Boolean hasReplicas();
  public java.lang.Integer getRevisionHistoryLimit();
  public A withRevisionHistoryLimit(java.lang.Integer revisionHistoryLimit);
  public java.lang.Boolean hasRevisionHistoryLimit();
  
  /**
   * This method has been deprecated, please use method buildSelector instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.LabelSelector getSelector();
  public io.fabric8.kubernetes.api.model.LabelSelector buildSelector();
  public A withSelector(io.fabric8.kubernetes.api.model.LabelSelector selector);
  public java.lang.Boolean hasSelector();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.SelectorNested<A> withNewSelector();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.SelectorNested<A> withNewSelectorLike(io.fabric8.kubernetes.api.model.LabelSelector item);
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.SelectorNested<A> editSelector();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.SelectorNested<A> editOrNewSelector();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.SelectorNested<A> editOrNewSelectorLike(io.fabric8.kubernetes.api.model.LabelSelector item);
  
  /**
   * This method has been deprecated, please use method buildStrategy instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.apps.DeploymentStrategy getStrategy();
  public io.fabric8.kubernetes.api.model.apps.DeploymentStrategy buildStrategy();
  public A withStrategy(io.fabric8.kubernetes.api.model.apps.DeploymentStrategy strategy);
  public java.lang.Boolean hasStrategy();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.StrategyNested<A> withNewStrategy();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.StrategyNested<A> withNewStrategyLike(io.fabric8.kubernetes.api.model.apps.DeploymentStrategy item);
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.StrategyNested<A> editStrategy();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.StrategyNested<A> editOrNewStrategy();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.StrategyNested<A> editOrNewStrategyLike(io.fabric8.kubernetes.api.model.apps.DeploymentStrategy item);
  
  /**
   * This method has been deprecated, please use method buildTemplate instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.PodTemplateSpec getTemplate();
  public io.fabric8.kubernetes.api.model.PodTemplateSpec buildTemplate();
  public A withTemplate(io.fabric8.kubernetes.api.model.PodTemplateSpec template);
  public java.lang.Boolean hasTemplate();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.TemplateNested<A> withNewTemplate();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.TemplateNested<A> withNewTemplateLike(io.fabric8.kubernetes.api.model.PodTemplateSpec item);
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.TemplateNested<A> editTemplate();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.TemplateNested<A> editOrNewTemplate();
  public io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.TemplateNested<A> editOrNewTemplateLike(io.fabric8.kubernetes.api.model.PodTemplateSpec item);
  public interface SelectorNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.LabelSelectorFluent<io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.SelectorNested<N>>{
    public N and();
    public N endSelector();
    
  }
  public interface StrategyNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.apps.DeploymentStrategyFluent<io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.StrategyNested<N>>{
    public N and();
    public N endStrategy();
    
  }
  public interface TemplateNested<N> extends io.fabric8.kubernetes.api.builder.Nested<N>,io.fabric8.kubernetes.api.model.PodTemplateSpecFluent<io.fabric8.kubernetes.api.model.apps.DeploymentSpecFluent.TemplateNested<N>>{
    public N and();
    public N endTemplate();
    
  }
  
}