package io.fabric8.kubernetes.api.model.apps;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ReplicaSetConditionBuilder extends io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionFluentImpl<io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.apps.ReplicaSetCondition,io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionBuilder>{
  public ReplicaSetConditionBuilder() {
    this(false);
  }
  public ReplicaSetConditionBuilder(java.lang.Boolean validationEnabled) {
    this(new ReplicaSetCondition(), validationEnabled);
  }
  public ReplicaSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionFluent<?> fluent) {
    this(fluent, false);
  }
  public ReplicaSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ReplicaSetCondition(), validationEnabled);
  }
  public ReplicaSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.apps.ReplicaSetCondition instance) {
    this(fluent, instance, false);
  }
  public ReplicaSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionFluent<?> fluent,io.fabric8.kubernetes.api.model.apps.ReplicaSetCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withLastTransitionTime(instance.getLastTransitionTime()); 
    fluent.withMessage(instance.getMessage()); 
    fluent.withReason(instance.getReason()); 
    fluent.withStatus(instance.getStatus()); 
    fluent.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  public ReplicaSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.ReplicaSetCondition instance) {
    this(instance,false);
  }
  public ReplicaSetConditionBuilder(io.fabric8.kubernetes.api.model.apps.ReplicaSetCondition instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withLastTransitionTime(instance.getLastTransitionTime()); 
    this.withMessage(instance.getMessage()); 
    this.withReason(instance.getReason()); 
    this.withStatus(instance.getStatus()); 
    this.withType(instance.getType()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.apps.ReplicaSetConditionFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.apps.ReplicaSetCondition build() {
    ReplicaSetCondition buildable = new ReplicaSetCondition(fluent.getLastTransitionTime(),fluent.getMessage(),fluent.getReason(),fluent.getStatus(),fluent.getType());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ReplicaSetConditionBuilder that = (ReplicaSetConditionBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}